from typing import Any

from src.crud.crud import get_prompt
from src.database import sync_db_helper

# ROLE = """
# Вы являетесь опытным маркетологом в компании,
#  которая разрабатывает программное обеспечение любой сложности на основе аутсорсинга.
#  Компания специализируется на:
# ✓ Backend: Python, ...
# ✓ Frontend: React, JS, CSS
# ✓ Мобильная разработка: Flutter, iOS/Android (Kotlin/Swift)
# ✓ Data Science & AI: машинное обучение, компьютерное зрение
# ✓ Кибербезопасность
#
# Ваша задача — анализировать переписку и находить потенциальных клиентов, которым нужна разработка ПО.
# """

ANALYTIC_PROMPT = """
Ты получаешь json с такими полями:
{
  "chats": [
    {
      "slice_id": "UUID4",
      "messages": [
        {
          "user_id": integer,
          "message_id": integer,
          "text": string,
          "date": "datetime"
        }
      ]
    }
  ]
}

Анализируй каждый чат отдельно.
Контекст диалога только в рамках одного slice_id.
 

К ПРИМЕРУ:Ты берешь в контекст сообщения в рамках slice_id 123456
и slice_id 654321 ОТДЕАЛЬНО.

{
  "chats": [
    {
      "slice_id": "123456",
      "messages": [
        {
          "user_id": integer,
          "message_id": integer,
          "text": string,
          "date": "datetime"
        },
         {
          "user_id": integer,
          "message_id": integer,
          "text": string,
          "date": "datetime"
        },
      ]
    },
    {
      "slice_id": "654321",
      "messages": [
        {
          "user_id": integer,
          "message_id": integer,
          "text": string,
          "date": "datetime"
        },
         {
          "user_id": integer,
          "message_id": integer,
          "text": string,
          "date": "datetime"
        },
      ]
    }
  ]
}

Ответ должен быть ТОЛЬКО в JSON формате, без каких-либо пояснений или форматирования.

Пример правильного ответа:
{
  "success": [
    {
      "user_id": 123,
      "slice_id": "550e8400-e29b-41d4-a716-446655440000",
      "reason": "Человек ищет покупку недвижимости под инвестиции."
    }
  ]
}

КРИТИЧЕСКИ, ЖИЗНЕННО ВАЖНО!!! при ответе в рамках массива success slice_id УНИКАЛЕН!

ТО ЕСТЬ ТАКОЕ НЕДОПУСТИМО

{
  "success": [
    {
      "user_id": 123,
      "slice_id": "550e8400-e29b-41d4-a716-446655440000",
      "reason": "Человек ищет покупку недвижимости под инвестиции."
    },
    {
      "user_id": 234,
      "slice_id": "550e8400-e29b-41d4-a716-446655440000",
      "reason": "Заинтересованных в покупке, аренде или инвестициях в коммерческую недвижимость Москвы (офисы класса A/B/C, ритейл, коворкинги)."
    }
  ]
}

ТУТ ТЫ ДОЛЖЕН ВЕРНУТЬ одного пользователя и slice_id который наиболее подходит под анализ.



Если нет четких признаков или есть сомнения, верни:
{"success": null}

Правила анализа:
%s
"""



def create_base_message() -> list[dict[str, Any]]:
    with sync_db_helper.session_factory() as session:
        prompt = get_prompt(session)

    return [
        {
            "role": "user",
            "parts": [
                {"text": prompt.role},
                {"text": ANALYTIC_PROMPT % prompt.prompt},
            ]
        },
    ]


print(create_base_message())