from time import sleep

from src.gemini_sdk.schemas import ChatMessageSchema, ResponseFromGeminiSchema
from src.gemini_sdk.service import gemini_helper
from src.rmq.connect import success_publisher
from src.schemas import MessagesForSendToWorkersSchema
from src.service.limter_checker import check_current_token_limit
from src.service.storage import MESSAGES_STORAGE_SCHEMA


async def handle_message_service(
        message_from_rmq: MessagesForSendToWorkersSchema,
) -> ResponseFromGeminiSchema | None:
    chat_message_schema = ChatMessageSchema(
        slice_id=message_from_rmq.slice_id,
        messages=message_from_rmq.messages
    )
    MESSAGES_STORAGE_SCHEMA.chats.append(chat_message_schema)

    if check_current_token_limit(
            model=gemini_helper._model
    ):
        return
    else:
        try:
            result = gemini_helper.create_request_ai(
                messages=MESSAGES_STORAGE_SCHEMA
            )
            sleep(60)
            if result.success is not None:
                await success_publisher.publish(result)

        finally:
            MESSAGES_STORAGE_SCHEMA.chats = []


