from faststream.rabbit import RabbitBroker, RabbitExchange, ExchangeType, QueueType, RabbitQueue
from src.core.settings.base import settings


broker = RabbitBroker(
    url=settings.RABBIT.URL,
)


base_exchange = RabbitExchange(
    name="base_exchange",
    type=ExchangeType.DIRECT,
)

base_queue = RabbitQueue(
    name="base_queue",
)
success_queue = RabbitQueue(
    name="success_queue",
)



message_handler_publisher = broker.publisher(
    queue=base_queue,
    exchange=base_exchange,
)

success_gemini_subscriber = broker.subscriber(
    queue=success_queue,
    exchange=base_exchange,
)


async def init_queue_and_publisher():
    await broker.declare_exchange(base_exchange)
    await broker.declare_queue(base_queue)
    await broker.declare_queue(success_queue)

