from telethon.errors.rpcerrorlist import MessageIdInvalidError

from src.core.database import TgMessage, TgChat, User
from src.core.settings.base import settings
from src.core.tg_service.notify_sender import send_to_tg_from_bot
from src.core.tg_service.utils import create_and_format_message, create_text_for_error_message_success

from src.telethon_client import telethon_client


async def notify_for_success(
        messages: list[TgMessage],
        chat: TgChat,
        success_reason: str,
        user_model: User,
) -> None:
    source_chat = await telethon_client.get_entity(int("-100" + str(chat.id)))

    message = create_and_format_message(
        reason=success_reason,
        user_model=user_model,
        chat=chat,
    )

    await send_to_tg_from_bot(
        text=message
    )

    for message in messages:
        try:
            await telethon_client.forward_messages(
                entity=settings.NOTIFY.CHAT_ID,
                messages=message.id,
                from_peer=source_chat,
            )
        except MessageIdInvalidError:
            await send_to_tg_from_bot(
                text=create_text_for_error_message_success(
                    "🔒 Удаленное сообщение\n\n"
                    "⚠️ Сообщение удалено или недоступно\n\n"
                    f"📝 Текст:`{message.text}`"
                    f"👤 ID_USER:`{message.user_id}`"
                )
            )
